647. Palindromic Substrings**

647. Palindromic Substrings**

https://leetcode.com/problems/palindromic-substrings/

题目描述

Given a string, your task is to count how many palindromic substrings in this string.

The substrings with different start indexes or end indexes are counted as different substrings even they consist of same characters.

Example 1:

Input: "abc"
Output: 3
Explanation: Three palindromic strings: "a", "b", "c".

Example 2:

Input: "aaa"
Output: 6
Explanation: Six palindromic strings: "a", "a", "a", "aa", "aa", "aaa".

Note:

  • The input string length won’t exceed 1000.

C++ 实现 1

class Solution {
private:
    int count(const string &s, int l, int r) {
        int res = 0;
        while (l >= 0 && r < s.size() && s[l--] == s[r++])
            res ++;
        return res;
    }
public:
    int countSubstrings(string s) {
        int res = 0, n = s.size();
        for (int i = 0; i < n; ++i) {
            res += count(s, i, i);
            res += count(s, i, i + 1);
        }
        return res;
    }
};

C++ 实现 2

参考了 Approach #1: Expand Around Center [Accepted]

class Solution {
public:
    int countSubstrings(string s) {
        int res = 0, n = s.size();
        for (int i = 0; i < 2 * n - 1; ++i) {
            int l = i / 2;
            int r = l + i % 2;
            while (l >= 0 && r < n && s[l--] == s[r++])
                res ++;
        }
        return res;
    }
};

C++ 实现 3

动态规划的方法. 使用 dp[i][j] 表示字符串 s[i,....j] 是否为回文串. 此时查找 dp[i][j]dp[i + 1][j - 1] 的关系就是查找 s[i, ..., j]s[i + 1,..., j - 1] 的关系. 由于 s[i, ..., j] 为回文串的要求是 s[i + 1,..., j - 1] 为回文串并且 s[i] == s[j], 因此有:

dp[i][j] = (s[i] == s[j]) && (dp[i + 1][j - 1])

另外注意, 对于 a, aa, aba 这样的子字符串, 大小 j - i < 3, 只需判断 s[i] 是否等于 s[j], 因此将递推公式改为:

dp[i][j] = (s[i] == s[j]) && (j - i < 3 || dp[i + 1][j - 1])

可以简化边界情况的考虑.

代码中 in - 1 变化到 0, 从后向前考虑.

class Solution {
public:
    int countSubstrings(string s) {
        int res = 0, n = s.size();
        vector<vector<bool>> dp(n, vector<bool>(n, false));
        for (int i = n - 1; i >= 0; --i)
            for (int j = i; j < n; ++j) {
                dp[i][j] = (s[i] == s[j]) && (j - i < 3 || dp[i + 1][j - 1]);
                if (dp[i][j]) ++ res;
            }
        return res;
    }
};
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值